;UT20 from Op Man for RCA CDS II CDP18S005
;hand entered and converted to modern 1802 asm
; by Herb Johnson last date Sep 3 2015
;split into ut20_1 and ut20_2
;
; UT20_2
;
; Register Definitions:
;
R0		EQU	0
R1		EQU	1
R2		EQU	2
R3		EQU	3
R4		EQU	4
R5		EQU	5
R6		EQU	6
R7		EQU	7
R8		EQU	8
R9		EQU	9
RA		EQU	10
RB		EQU	11
RC		EQU	12
RD		EQU	13
RE		EQU	14
RF		EQU	15

;
; I/O Port Definitions:
;
P1		EQU	1
P2		EQU	2
P3		EQU	3
P4		EQU	4
P5		EQU	5
P6		EQU	6
P7		EQU	7

	ORG	8400H
;THIS ROUTINE IS USED TO LOAD A PROGRAM
;WRITTEN IN UT2 FORMAT FROM ICOM FDKS
;INTO MEMORY. THIS PROGRAM STARTS ASKING
;FOR THE TRACK # AND UNIT #. THESE
;NUMBERS SHOULD BE ENTERED FROM
;TERMINAL AS HEX DIGITS, THEN THE PROGRAM
;SEEKS THE U/TR AND LOAD THE PGM

IRX	EQU	60H
TYPE2 EQU 81AEh
PTER	EQU	0CH
ST	EQU	02H
PC	EQU	03H
ASL	EQU	0DH
AUX	EQU	0EH
;I/O PARAMETERS
READAH EQU	813BH
TYPE	EQU	81A4H
OSTRNG EQU	83F0H
DSKGO	EQU	83F6H	
GOUT20 EQU	83F9H
CKHEX EQU	83FCH	

	LDI	LOW(START-6)
	PLO	R3
	LDI	HIGH(START)
	PHI	R3
	LBR	DSKGO
	LDI	1FH
	PLO	R2
	LDI	8CH
	PHI	R2
START: LDI	0H	;<-duplicates earlier addr
	PLO	ASL
	PHI	ASL
	PHI	RA
	STXD
ASK:	SEP	R4
	DW	OSTRNG
	DB	0DH
	DB	0AH
	DB	'READ?'
	DB	0H

ASK1:	SEP	R4
	DW	READAH
	XRI	0DH
	BNZ	ASK1
	SEP	R4
	DW	OSTRNG
	DB	0AH
	DB	'LOADING'
	DB	00H

	SEX	R3
	OUT	4
	DB	0H
	GHI	ASL
	BZ	CONTIN
	LDI	40H
	OUT	4
	DB	40H
CONTIN: STR	ST
	DEC	ST
	OUT	5
	DB	21H
	OUT	5
	DB	0BH
	OUT	5
	DB	0DH

CVY:	SEX	R2
	GLO	ASL
	SMI	10H
	BNF	RESULT
	PLO	ASL
	GHI	RA
	ADI	0AH
	PHI	RA
	BR	CVY
RESULT: GLO	ASL
	STR	ST
	GHI	RA
	ADD
	STXD
	GLO	ST
	PLO	PTER
	GHI	ST
	PHI	PTER
	INC	PTER
	INC	PTER
	INC	PTER
	SEP	R4
	DW	EWAIT
READX: SEP	R4
	DW	READ
	LBNF	GOUT20
	XRI	21H
	BZ	ISITM
	XRI	05H
	BZ	ISITU
	XRI	37H
	BNZ	READX
DONE:	SEP	R4
	DW	OSTRNG
	DB	00H
	LBR	GOUT20

ISITM: SEP	R4
	DW	READ
	LBNF	GOUT20
	XRI	'M'	;4DH
	BNZ	ERRORX
READX1: SEP	R4
	DW	READHX
	BDF	READX2
	XRI	'.'	;2EH
	BNZ	READX1
READXA: SEP	R4
	DW	 READ
	LBNF	GOUT20
	XRI	0DH
	BNZ	READXA
	BR	READX1
READX2: SEP	R4
	DW	READHX

	BDF	READX2
	XRI	20H
	BNZ	ERRORX
	GLO	ASL
	PLO	R8
	GHI	ASL
	PHI	8
READX3: SEP	R4
	DW	READHX
	BNF	READX4

READXB: SEP	R4
	DW	READHX

	BNF	ERRORX
	GLO	ASL
	STR	R8

	SEX	R8
	XOR
	BZ	WRTOK
	SEP	R4
	DW	NOTRAM
WRTOK: INC	R8
	BR	READX3
READX4: XRI	0DH
	BZ	READX
	XRI	36H	;SEMICOLON
	BZ	READXA
	BR	READX3
ISITU: SEP	R4
	DW	READ
	LBNF	GOUT20
	XRI	'U'
	BNZ	ERRORX
ADLP: SEP	R4
	DW READHX
	BDF	ADLP
	GLO	ASL
	PLO	R0
	GHI	ASL
	PHI	R0
	SEP	R4
	DW	OSTRNG
	DB	0DH
	DB	0AH
	DB	00H
	SEX	R0
	SEP	R0
ERRORX: SEP	R4
	DW	OSTRNG
	DB	0DH
	DB	0AH
	DB	'FORMAT ERROR'
	DB	00H

	LBR	GOUT20

;SUBROUTINES
READHX: SEP	R4
	DW	READ
	LBNF	GOUT20
	SEP	R4
	DW	CKHEX
EXIT:	SEP	R5
	
	ORG	8500H
;BRANCH POINTS
;
EWRITE: BR	WRITE
EREAD: BR	READ
ETRNFR: BR	TRNFR1
EWAIT: BR	WAIT1
DER:	LBR	DERROR
EWAITD: LBR	WAIT
LINEPR: LBR	PRNTRF
;
WAIT1: SEX	R2
	INP	6
	SHR
	BDF	WAIT1
	SEP	R5

TRNFR1: LDI	10H
	PLO	RF
	LDA	PTER
	STR	R2
	OUT	4
	DEC	R2
	SEX	R3
	OUT	5
	DB	11H
	SEX	R2
	LDA	PTER
	STR	R2
	OUT	4
	DEC	R2	;<--is this a trick?
	SEX	R3
	OUT	5
	DB	21H
	NOP
	NOP
	NOP
	NOP
	OUT	5
	DB	09H
	SEP	R4
	DW	WAIT
	GHI	RF
	SHL
	BDF	TRNEXT
	INP	6
	ANI	08H
	BZ	RDWTCK
	GHI	RF
	ORI	40H
	PHI	RF
	BR	TRKNG
RDWTCK: SEX	R3
	OUT	5
	DB	0BH
	GHI	RF
	SHR
	BDF	WRTCK
	OUT	5
	DB	03H
	BR	STATUS
WRTCK: OUT	5
	DB	05H
	SEP	R4
	DW	WAIT
	SEX	R3
	OUT	5
	DB	07H
STATUS: SEP	R4
	DW	WAIT
	INP	6
	ANI	08H
	BZ	TRNEXT
	DEC	RF

	GLO	RF
	BNZ	RDWTCK
	SEP	R4
	DW	DERROR
	GHI	RF
	ANI	01H
	ORI	20H
	PHI	RF
	BR	TRNEXT
TRKNG: SEP	R4
	DW	DERROR
TRNEXT: GHI	RF
	XRI	0FFH
	SHL
	SEP	R5

READ:	SEX	PTER
	LDI	00H
	PHI	RF
	LDX
	BNZ	SHFTBR
REREAD: LDI	00H
	PHI	RF
	LDI	80H
	STXD
	LDX
	ADI	01H
	STXD

	ANI	1FH
	SDI	1AH
	BDF	CNTOK
	INC	PTER
	LDX
	ANI	0C0H
	ADI	01H
	STXD

	LDX
	ANI	01H
	STR	PTER
CNTOK: LDX
	SDI	4CH
	BDF	TRKOK
	INC	PTER
	INC	PTER
	SEX	R3
	OUT	5
	DB	00H
	BR	TRKNG
TRKOK: SEX	R2
	SEP	R4
	DW	TRNFR1
	BNF	RDXIT
	SEX	PTER
	GHI	RF
	ANI	20H
	BNZ	REREAD

	LDI	40H
	LSKP
SHFTBR: LDI	41H
	STR	R2
	SEX	R2
	OUT	5
	DEC	R2
	INP	6
	PLO	RF
	LDN	PTER
	SMI	01H
	STR	PTER

RDXIT: GHI	RF
	XRI	0FFH
	SHL

	GLO	RF
	LSDF
	LDI	13H
	PHI	RF
	SEP	R5

WRITE: GHI	RF
	STR	R2
	OUT	4
	DEC	R2
	LDI	01H
	PHI	RF
	SEX	R3
	OUT	5
	DB	31H
	SEX	PTER
	LDX
	ADI	01H
	STR	PTER
	SMI	80H
	LBNF	EXWT
REWRIT: LDI	01H
	PHI	RF
	LDI	00H
	STXD
	LDX
	ADI	01H
	STXD

	ANI	1FH
	SDI	1AH
	BDF	WTCNT
	INC	PTER
	LDX
	ANI	0C0H
	ADI	01H
	STXD

	LDX
	ADI	01H
	STR	PTER
WTCNT: LDX
	SDI	4CH
	BDF	TRK0K1
	INC	PTER
	INC	PTER
	BR	TRKNG
TRK0K1: SEX	R2
	SEP	R4
	DW	TRNFR1

	SEX	PTER
	GHI	RF
	ANI	20H
	LBNZ	REWRIT

EXWT:	GHI	RF
	XRI	0FFH
	SHL
	SEP	R5

WAIT:	SEX	R2
	INP	6
	ANI	20H
	BNZ	FAILUR
	INP	6
	ANI	40H
	BNZ	NOFAIL
FAILUR: LDI	00H
	PLO	RF
	SEP	R4
	DW	DERROR

NOFAIL: INP	6
	ANI	08H
	BNZ	RETWAT
	INP	6
	SHR
	BDF	WAIT
RETWAT: SEP	R5

DERROR: SEX	R2
	GHI	RC
	STXD
	GLO	RC
	STXD
	GHI	RF
	STXD
	GLO	RF
	STXD
	GHI	RA
	STXD
	GLO	RA
	STXD
	DEC 	RC
	LDN	RC
	ANI	7FH
	PLO	RA

	DEC	RC
	LDN	RC
	PHI	RA
	GHI	RF
	STXD
	ANI	40H
	BZ	ERR10
	SEP	R4
	DW	OSTRNG
	DB	0DH
	DB	0AH
	DB	'TRACK SEEK ERROR'
	DB	00H

	BR	RDWRPT
ERR10: INP	6
	ANI	20H
	BZ	ERR20
	SEP	R4
	DW	OSTRNG
	DB	0DH
	DB	0AH
	DB	'DRIVE FAILURE'
	DB	00H

	BR	RDWRPT
ERR20: INP	6
	ANI	08H
	BZ	ERR30
	SEP	R4
	DW	OSTRNG
	DB	0DH
	DB	0AH
	DB	'CRC ERROR'
	DB	00H

	GLO	RA
	ORI	80H
	PLO	RA
	BR	RDWRPT
ERR30: INP	6
	ANI	40H
	BNZ	ERR40
	SEP	R4
	DW	OSTRNG
	DB	0DH
	DB	0AH
	DB	'DRIVE NOT ACTIVE'
	DB	00H

	IRX
	LBR	DERXT
ERR40: SEP	R4
	DW	OSTRNG
	DB	0DH
	DB	0AH
	DB	'TRACK >76'
	DB	00H

RDWRPT: IRX
	LDX
	SHR
	BDF	WROP
RDOP: SEP	R4
	DW	OSTRNG
	DB	' DURING READ'
	DB	00H

	BR	UTSPT
WROP: SEP	R4
	DW	OSTRNG
	DB	' DURING WRITE'
	DB	00H

UTSPT: SEP	R4
	DW	OSTRNG
	DB	' UNIT '
	DB	00H

	GLO	RA
	ANI	40H
	LSZ
	LDI	01H
	ADI	30H
	PHI	RF
	SEP	R4
	DW	TYPE
	SEP	R4
	DW	OSTRNG
	DB	', TRACK '
	DB	00H

	GHI	RA
	PHI	RF
	SEP	R4
	DW	TYPBCD
	SEP	R4
	DW	OSTRNG
	DB	', SECTOR '
	DB	00H

	GLO	RA
	ANI	1FH
	PHI	RF
	SEP	R4
	DW	TYPBCD
	GLO	RA
	ANI	80H
	BZ	NOSKIP

	SEP	R4
	DW	OSTRNG
	DB	' SKIPPED'
	DB	00H

NOSKIP: SEP	R4
	DW	OSTRNG
	DB	0DH
	DB	0AH
	DB	00
DERXT: IRX
	LDXA
	PLO	RA
	LDXA	
	PHI	RA
	LDXA
	PLO	RF
	LDXA

	ANI	01
	ORI	80H
	PHI	RF
	LDXA
	PLO	RC
	LDX
	PHI	RC
	SEX	R3
	OUT	5
	DB	0BH
	SEP	R5

TYPBCD: GHI	RF
	ANI	0F0H
	SHR
	SHR
	SHR
	SHR
	PLO	RF
	GHI	RF
	ANI	0FH
	PHI	RF
	SMI	10D
	BNF	SIXLP
	GHI	RF
	ADI	6
	PHI	RF
SIXLP: GLO	RF
	BZ	EXITBC
	DEC	RF
	GHI	RF
	ADI	16H
	PHI	RF
	ANI	0FH
	SMI	10D
	BNF	SIXLP
	GHI	RF
	ADI	6
	PHI	RF
	BR	SIXLP
EXITBC: SEP	R4
	DW	TYPE2
	SEP	R5

NOTRAM: GLO	RC
	STXD
	GHI	RC
	STXD
	SEP	R4
	DW	OSTRNG
	DB	0DH
	DB	0AH
	DB	'RAM AT '
	DB	00H

	GHI	R8
	PHI	RF
	SEP	R4
	DW	TYPE2
	GLO	R8
	PHI	RF
	SEP	R4
	DW	TYPE2
	SEP	R4
	DW	OSTRNG
	DB	' ?'
	DB	00H

	INC	R2
	LDA	R2
	PHI	RC
	LDN	R2
	PLO	RC
	SEP	R5

;THIS ROUTINE PRINTS TO THE LINE PRINTER, THE CONTENTS OF HIGH RF
;IT SUPRESSES PRINTING OF LINE FEEDS, AND REPLACES CARRIAGE RETURNS
;WITH A CR-LF PAIR.
;NORMALLY, THIS ROUTINE RETURNS WITH THE DFLAG SET, BUT IF THE
;CHARACTER IN HIGH RF WAS A DC3(END OF FILE), THE DFLAG WILL BE RESET
;ON RETURN. 

PRNTRF: GHI	RF
	XRI	0AH
	BZ	EXITDF
	GHI	RF
	XRI	13H
	BZ	EXITEF
PRINT1: GHI	RF
	XRI	0FFH
	STR	R2
	B1	$
	OUT	6
	DEC	R2
	GHI	RF
	XRI	0DH
	BNZ	EXITDF
	LDI	0AH
	PHI	RF
	BR	PRINT1
EXITDF: LDI	01H
	SHR
	SEP	R5
EXITEF: SHR
	SEP	R5	
	END


























